/*
 * StoresView.java
 *
 * Created on 10 de agosto de 2004, 18:00
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.StoreList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.StoreListViewShopKeeper;

/**
 * Este servlet carga la lista de establecimientos para un minorista dado, y a
 * partir de esta construye una vista (listado) que será presentada en la página
 * mis establecimientos.jsp.
 * 
 * @author Mario Linares Vásquez
 */
public class StoresView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor de servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa solicitudes para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>. Este método crea una instancia de la clase <CODE>
	 * StoreList</CODE> con el id del atributo <CODE>user</CODE> de la sesión
	 * y a partir de este objeto construye la respectiva vista, que es instancia
	 * de <CODE>StoreListView</CODE>, y la agrega al <CODE>response</CODE>
	 * como atributo con el nombre <CODE>view</CODE>. Al final del proceso el
	 * flujo es redireccionado a la página misestablecimientos.jsp
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		String url = "/minorista/misestablecimientos.jsp";
		String message = "";
        HttpSession session = request.getSession( false );		

	    try
	    {
	        if( session != null && ( User )session.getAttribute( "user" ) != null && ( ( User )session.getAttribute( "user" ) ).getRoleId() == 3 )
			{
				String error = (String) request.getAttribute("error");
				if( error != null )
				{
					if( error.equals("delete") )
					{
						request.setAttribute("error", request.getAttribute("message"));
					}
				}
	
				int roleId = ((User) request.getSession().getAttribute("user"))
						.getRoleId();
				int companyId = ((User) request.getSession().getAttribute("user"))
						.getCompanyId();
	
				StoreList list = new StoreList(companyId);
				StoreListViewShopKeeper view = new StoreListViewShopKeeper(list);
	
				request.setAttribute("view", view);
			}
			else
			{
				message = MessageBuilder.buildMessage(15);
				url = "/index.jsp";
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code> method.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}